﻿using UnityEngine;

namespace script
{
    public class script
    {

        public static void Main()
        {
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Axe"),
                    NameOverride = "Survaival Axe -RA",
                    DescriptionOverride = "A very useful, sharp and compact item \n cuts objects randomly",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("Axethumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var axeHandle = Instance.transform.GetChild(0);
                        axeHandle.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Axe.png");
                        var axeHead = axeHandle.GetChild(0);
                        axeHead.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AxeHead.png");
                        axeHead.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Plastic");
                        var properties = ModAPI.FindPhysicalProperties("Metal");
                        properties.Sharp = true;
                        properties.SharpAxes = new SharpAxis[]
                        {
                            new SharpAxis(Vector2.right, 0f, 0.5f, true, false)
                        };
                        axeHead.gameObject.GetComponent<PhysicalBehaviour>().Properties = properties;
                        Instance.transform.FindChild("Axe handle").FindChild("Axe head").gameObject.AddComponent<RandomSplit>();
                    }
                }
            );
            ModAPI.Register(
               new Modification()
               {
                   OriginalItem = ModAPI.FindSpawnable("Axe"),
                   NameOverride = "Fire Axe -RA",
                   DescriptionOverride = "A tough kind of axe, \n needs around 3 hits to cut an object.",
                   CategoryOverride = ModAPI.FindCategory("Melee"),
                   ThumbnailOverride = ModAPI.LoadSprite("Axethumb2.png"),
                   AfterSpawn = (Instance) =>
                   {
                       var axeHandle = Instance.transform.GetChild(0);
                       axeHandle.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Axe2.png");
                       var axeHead = axeHandle.GetChild(0);
                       axeHead.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AxeHead2.png");
                       var properties = ModAPI.FindPhysicalProperties("Metal");
                       properties.Sharp = true;
                       properties.SharpAxes = new SharpAxis[]
                       {
                            new SharpAxis(Vector2.right, 0f, 0.5f, true, false)
                       };
                       axeHead.gameObject.GetComponent<PhysicalBehaviour>().Properties = properties;
                       Instance.transform.FindChild("Axe handle").FindChild("Axe head").gameObject.AddComponent<HardSplit>();
                   }
               }
           );
        }

    }
    public class RandomSplit : MonoBehaviour
    {
        private void Lodged(Stabbing stabbing)
        {

            if (stabbing.victim.GetComponent<LimbBehaviour>() != null)
            {
                var rand = Random.Range(0, 4);
                if (rand == 1)
                {

                    var limbBehaviour = stabbing.victim.GetComponent<LimbBehaviour>();
                    limbBehaviour.BreakingThreshold = -100000f;
                }
            }
        }
    }
    public class HardSplit : MonoBehaviour
    {
        int stab = 0;
        private void Lodged(Stabbing stabbing)
        {
            
            if (stabbing.victim.GetComponent<LimbBehaviour>() != null)
            {
                
                stab++;
               
                if (stab == 3)
                {

                    var limbBehaviour = stabbing.victim.GetComponent<LimbBehaviour>();
                    limbBehaviour.BreakingThreshold = -100000f;
                    stab = 0;
                }
            }
        }
    }
}